#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    int n, q;
    cin >> n >> q;
    vector<int>a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<int>b(n);
    for(int i = 0; i < n; i++){
        b[i] = floor(log2(a[i]));
    }
    for(int i = 0; i < q; i++){
        int l, r, max = 1;
        cin >> l >> r;
        l--; r--;
        vector<int>c(30, 0);
        for(int j = l; j <= r; j++){
            c[b[j]]++;
        }
        for(int j = 0; j < 30; j++){
            if(c[j] > max){
                max = c[j];
            }
        }
        cout << max << '\n'; 
    }
    return 0;
}